/*->c.dbox */


#include <stdafx.h>
#include "resource.h"


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "flex.h"
#include "deb.h"

#include "wos.h"
#include "poll.h"
#include "save.h"
#include "err.h"
#include "task.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "etc.h"
#include "config.h"
#include "bf.h"
#include "bits.h"
#include "arcs.h"
#include "akbd.h"
#include "key.h"
#include "pane.h"
#include "mlo.h"
#include "getdir.h"
#include "osshell.h"
#include "timex.h"
#include "appinfo.h"
#include "oshelp.h"
#include "comctls.h"

#include "constants.h"

#include "reslink.h"


#include "syncdiscs.h"

#include "main.h"
#include "dbox.h"
#include "zone.h"








       int syncdiscshandle;
static int mpicon;

static int newer;
static int extra;

static int log;
static int logappend;

static int overwrite;
static int timeresolution;

static int scrapauto;


/****************************************************************************/

static int progresshandle;
static int progressescape;

static os_error * progressicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==IDC_CANCEL) progressescape=1;

 return(err);

 USE(handle);
 USE(userhandle);
}


static os_error * progresskey(int handle,int userhandle,int icon,int * key)
{
 os_error    * err;

 err=NULL;

 if(*key==ESCAPE)
 {
  progressescape=1;
  *key=-1;
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(icon);
}


os_error * progressupdate(char * name)
{
 os_error * err;

 err=NULL;

 if(progresshandle)
 {
  writeicon(progresshandle,IDC_MESSAGE,name);

  poll();

  if(progressescape) err=geterror(ECANCEL);
 }

 return(err);
}



static void szero(int userhandle)
{
 USE(userhandle);
}



static os_error * progressclose(void)
{
 os_error * err;

 enablewindow(syncdiscshandle,1,0);

 remkeyevent(progresskey,progresshandle,0);
 remclickevent(progressicon,progresshandle,0);
 remzeroevent(szero,0);

 err=closedown(&progresshandle);

 return(err);
}



static os_error * progressopen(void)
{
 os_error * err;

 err=createwindowparent(TPROGRESS,&progresshandle,syncdiscshandle);
 if(!err)
 {
  addkeyevent(progresskey,progresshandle,0);
  addclickevent(progressicon,progresshandle,0);
  addzeroevent(szero,0);

  err=popup(progresshandle,0);

  enablewindow(syncdiscshandle,0,0);
 }

 progressescape=0;

 return(err);
}



/****************************************************************************/



static os_error * viewdir(int icon,int handle)
{
 os_error * err;
 char       savepath[MAX_PATH];

 err=NULL;

 readicon(handle,icon,savepath,MAX_PATH);

 oscommand(handle,"open",savepath,NULL,NULL,0);

 return(err);
}



static os_error * syncdiscsloadtype(char * name,int type,mousestr * m,int userhandle,
                                                               int * method)
{

 mpicon=m->icon;

 cprintf("loadtype %d",mpicon);

 if(*method==0 && (mpicon==IDC_PRINAME || mpicon==IDC_SECNAME || 
                   mpicon==IDC_SCRAPNAME)) *method=1;
 else                                      *method=0;

 return(NULL);

 USE(type);
 USE(userhandle);
 USE(name);
}




static os_error * syncdiscsload(char * name,int type,
                                              int userhandle,int xv)
{
 os_error * err;
 char       path[NAMELEN];
 char       path2[NAMELEN];
 char     * p;

 strcpy(path,name);

 if(isctrl)
 {
  p=fs_leaf(path);
  if(p!=path) *(p-1)=0; // end up with C: for root
 }

 if(isshift)
 {
  iconaddr(syncdiscshandle,mpicon,&p);
  strcpy(path2,p);
  strcat(path2,"|");
  strcat(path2,path);
  err=writeicon(syncdiscshandle,mpicon,path2);
 }
 else
 {
  err=writeicon(syncdiscshandle,mpicon,path);
 }

 return(err);

 USE(type);
 USE(userhandle);
 USE(xv);
}









static char       primary[MAX_PATH];
static char       secondary[MAX_PATH];
static char       scrap[MAX_PATH];
static char       logfile[MAX_PATH];




static os_error * getpri(char * path)
{
 return(writeicon(syncdiscshandle,IDC_PRINAME,path));
}



static os_error * getsec(char * path)
{
 return(writeicon(syncdiscshandle,IDC_SECNAME,path));
}



static os_error * getscrap(char * path)
{
 return(writeicon(syncdiscshandle,IDC_SCRAPNAME,path));
}


static char * defltdir="C:\\";


#ifdef NEVER

static os_error * syncdiscsdb2(void * param)
{
 os_error * err;
 int        thread;

 err=createthread(syncdiscsdb2,NULL,&thread);

 return(err);
 USE(param);
}

#endif


os_error * syncdiscsdb(void)
{
 os_error * err;

 progressopen();
 err=syncdiscs(primary,secondary,scrap,log?logfile:NULL,newer|(extra<<1)|(overwrite<<2),timeresolution);
 progressclose();

 return(err);
}



os_error * dbcompare(void)
{
 os_error * err;

 err=syncdiscs(primary,secondary,scrap,NULL,newer|(extra<<1)|(overwrite<<2)|(1<<3),timeresolution);

 return(err);
}





static os_error * syncdiscsicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;


 err=NULL;

 switch(m->i)
 {
  case  IDC_START:
          err=configsave();
          if(!err) err=syncdiscsdb();
          break;

  case  IDC_COMPARE:
           err=configsave();
           if(!err) err=dbcompare();
           break;


  case  IDC_NEWER:
          err=selectst(handle,IDC_NEWER,newer^=1);
          break;

  case  IDC_EXTRA:
          err=selectst(handle,IDC_EXTRA,extra^=1);
          break;

  case IDC_OVERWRITE:
          err=selectst(handle,IDC_OVERWRITE,overwrite^=1);
          break;


  case IDC_VIEWSCRAP:
          err=viewdir(IDC_SCRAPNAME,handle);
          break;

  case IDC_VIEWPRIMARY:
          err=viewdir(IDC_PRINAME,handle);
          break;
  
  case IDC_VIEWSECONDARY:
          err=viewdir(IDC_SECNAME,handle);
          break;

          
  case IDC_PRIDIR:
          readicon(syncdiscshandle,IDC_PRINAME,primary,sizeof(primary));
          if(!strlen(primary)) strcpy(primary,defltdir);
//          err=getdir(handle,primary,getpri);
          err=osshellbrowseforfolder(primary,"",handle,0);
          if(!err) err=getpri(primary);
          break;

  case IDC_SECDIR:
          readicon(syncdiscshandle,IDC_SECNAME,secondary,sizeof(secondary));
          if(!strlen(secondary)) strcpy(secondary,defltdir);
//          err=getdir(handle,secondary,getsec);
          err=osshellbrowseforfolder(secondary,"",handle,0);
          if(!err) err=getsec(secondary);
          break;

  case IDC_SCRAPDIR:
          readicon(syncdiscshandle,IDC_SCRAPNAME,scrap,sizeof(scrap));
//          if(!strlen(scrap)) strcpy(scrap,defltdir);
//          err=getdir(handle,scrap,getscrap);
          err=osshellbrowseforfolder(scrap,"",handle,0);
          if(!err) err=getscrap(scrap);
          break;


 }

 return(err);

 USE(userhandle);
}




static os_error * syncdiscskey(int handle,int userhandle,int icon,int * key)
{
 os_error    * err;
 int           ch;
 wimp_mousestr m;

 err=NULL;

 ch=*key;

 if(ch==RETURN)
 {
  *key=-1;
  m.i=IDC_START;
  err=syncdiscsicon(handle,userhandle,&m);
 }
 else
 if(ch==ESCAPE)
 {
  *key=-1;
  m.i=IDC_CANCEL;
  err=syncdiscsicon(handle,userhandle,&m);
 }

 return(err);

 USE(icon);
}






os_error * syncdiscsclose(int w,int userhandle)
{
 os_error * err;

 configsave();

 remkeyevent(syncdiscskey,syncdiscshandle,0);
 remclickevent(syncdiscsicon,syncdiscshandle,0);
 remcloseevent(syncdiscsclose,syncdiscshandle,0);
 remdataload(syncdiscshandle,0,syncdiscsload);
 remdataloadtype(syncdiscshandle,0,syncdiscsloadtype);

 err=closedown(&syncdiscshandle);

 pollquit(0);

 return(err);

 USE(userhandle);
 USE(w);
}





os_error * opensyncdiscs(void)
{
 os_error * err;

 if(syncdiscshandle) err=forward(syncdiscshandle,0,NULL);
 else
 {
  cprintf("opensync");
  err=createwindow(TSYNCDISCS,&syncdiscshandle);
  if(!err)
  {
   cprintf("create sync %d",syncdiscshandle);
   addkeyevent(syncdiscskey,syncdiscshandle,0);
   addclickevent(syncdiscsicon,syncdiscshandle,0);
   addcloseevent(syncdiscsclose,syncdiscshandle,0);

   adddataload(syncdiscshandle,0,syncdiscsload);
   adddataloadtype(syncdiscshandle,0,syncdiscsloadtype);

   selectst(syncdiscshandle,IDC_NEWER,newer);
   selectst(syncdiscshandle,IDC_EXTRA,extra);
   selectst(syncdiscshandle,IDC_OVERWRITE,overwrite);


   writeicon(syncdiscshandle,IDC_PRINAME,primary);
   writeicon(syncdiscshandle,IDC_SECNAME,secondary);
   writeicon(syncdiscshandle,IDC_SCRAPNAME,scrap);


   addwindowmenu(syncdiscshandle,MMAIN);

   err=popup(syncdiscshandle,0);
   if(!err)
   {
    setfocus(syncdiscshandle);
   }
  }
 }
 return(err);
}





static contag contable[]=
{
 "Primary",     CONSTR,  NULL,  (contokstr*)0,  NULL,
 "Secondary",   CONSTR,  NULL,  (contokstr*)0,  NULL,
 "Scrap",       CONSTR,  NULL,  (contokstr*)0,  NULL,
 "LogFile",     CONSTR,  NULL,  (contokstr*)0,  NULL,
 "Newer",       CONINT,  &newer,         NULL,  NULL,
 "Extra",       CONINT,  &extra,         NULL,  NULL,
 "Overwrite",   CONINT,  &overwrite,     NULL,  NULL,
 "Log",         CONINT,  &log,           NULL,  NULL,
 "Logappend",   CONINT,  &logappend,     NULL,  NULL,
 "TimeRes",     CONINT,  &timeresolution,NULL,  NULL,

 NULL,0,NULL,NULL,NULL
};


static conlink configlink=
{
 "SyncDiscs",
 NULL,
 NULL
};




static char * registrypath="HKEY_CURRENT_USER\\Software\\David Pilling\\SyncDiscs";


os_error * configsave(void)
{

 if(syncdiscshandle)
	{
  readicon(syncdiscshandle,IDC_PRINAME,primary,sizeof(primary));
  readicon(syncdiscshandle,IDC_SECNAME,secondary,sizeof(secondary));
  readicon(syncdiscshandle,IDC_SCRAPNAME,scrap,sizeof(scrap));
 }

 return(saveconfigregistry(registrypath));
}



static os_error * syncend(int eventn,int userhandle,void * data,int data1)
{
 return(configsave());
 USE(data1);
 USE(data);
 USE(userhandle);
 USE(eventn);
}



os_error * configinit(void)
{
 os_error  * err;

 err=NULL;

 contable[0].address=primary;
 contable[0].data.len=sizeof(primary);

 contable[1].address=secondary;
 contable[1].data.len=sizeof(secondary);

 contable[2].address=scrap;
 contable[2].data.len=sizeof(scrap);

 contable[3].address=logfile;
 contable[3].data.len=sizeof(logfile);

 if(!err) err=addcontable(contable,&configlink);

 if(!err)
 {
  err=loadconfigregistry(registrypath);
  if(err) err=NULL; // allow for registry entries not existing
 }

 strcpy(sysdstring,"%ZDY %M3 %YR");
 strcpy(syststring,"%Z24:%MI%AM");


 if(!err) err=addevent(EVENT_ENDPROGRAM,syncend,0);

 return(err);
}


os_error *  commandline(int argc,char * argv[],int * quit)
{
 os_error * err;
 int        i;

 err=NULL;
 *quit=0;

 for(i=1;i<argc;i++)
 {
  if(!cstrcmp(argv[i],"-quit")) *quit=1;
  else
  if(!cstrcmp(argv[i],"-primary"))
  {
   i++;
   if(i<argc) strcpy((char*)contable[0].address,argv[i]);
   else       err=geterror(EMISS);
  }
  else
  if(!cstrcmp(argv[i],"-secondary"))
  {
   i++;
   if(i<argc) strcpy((char*)contable[1].address,argv[i]);
   else       err=geterror(EMISS);
  }
  else
  if(!cstrcmp(argv[i],"-scrap"))
  {
   i++;
   if(i<argc) strcpy((char*)contable[2].address,argv[i]);
   else       err=geterror(EMISS);
  }
  else
  if(!cstrcmp(argv[i],"~scrap"))
  {
   *((char*)contable[2].address)=0;
  }
  else
  if(!cstrcmp(argv[i],"-log"))
  {
   i++;
   if(i<argc) strcpy((char*)contable[3].address,argv[i]);
   else       err=geterror(EMISS);
   log=1;
  }
  else
  if(!cstrcmp(argv[i],"~rule"))
  {
   zoneclear();
  }
  else
  if(!cstrcmp(argv[i],"-rule"))
  {
   i++;
   if(i<argc) err=addzone(argv[i]);
   else       err=geterror(EMISS);
  }
  else
  if(!cstrcmp(argv[i],"-timeres"))
  {
   i++;
   if(i<argc) timeresolution=atoi(argv[i]);
   else       err=geterror(EMISS);
  }
  else
  if(!cstrcmp(argv[i],"~log"))
  {
   log=0;
  }
  else
  if(!cstrcmp(argv[i],"-extra"))
  {
   extra=1;
  }
  else
  if(!cstrcmp(argv[i],"~extra"))
  {
   extra=0;
  }
  else
  if(!cstrcmp(argv[i],"-newer"))
  {
   newer=1;
  }
  else
  if(!cstrcmp(argv[i],"~newer"))
  {
   newer=0;
  }
  else
  if(!cstrcmp(argv[i],"-overwrite"))
  {
   overwrite=1;
  }
  else
  if(!cstrcmp(argv[i],"~overwrite"))
  {
   overwrite=0;
  }
  else err=geterror(ECOMM);
 }


//	*quit=0;

 if(!err && *quit)
 {
  err=syncdiscs((char*)contable[0].address,
                (char*)contable[1].address,
                (char*)contable[2].address,
                log?(char*)contable[3].address:NULL,
                newer|(extra<<1)|(overwrite<<2),timeresolution);
 }

 return(err);
}



/*******************************************************************************/


static int optionshandle;

static os_error * optionsclose(int w,int userhandle);



static os_error * optionsicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;


 err=NULL;

 switch(m->i)
 {

   case IDC_SCRAPAUTO:
                      selectst(handle,IDC_SCRAPAUTO,scrapauto^=1);
                      break;

            case IDOK:
                      err=optionsclose(handle,1);
                      break;

        case IDCANCEL:
                      err=optionsclose(handle,0);
                      break;

 }

 return(err);

 USE(userhandle);
}




static os_error * optionskey(int handle,int userhandle,int icon,int * key)
{
 os_error    * err;
 int           ch;
// wimp_mousestr m;

 err=NULL;

 ch=*key;

 return(err);

 USE(icon);
}






static os_error * optionsclose(int w,int ok)
{
 os_error * err;
 char       temp[1024];
 char     * p;
 char     * q;
 int        ch;

 if(ok)
 {
  readicon(w,IDC_TRES,temp,sizeof(temp));
  timeresolution=atoi(temp);

  zoneclear();
  readicon(w,IDC_RULES,temp,sizeof(temp));
  p=temp;
  while(1)
  {
   while(*p<' ' && *p!=0) p++;
   q=p;
   while(*p>=' ') p++;
   ch=*p;
   *p=0;
   if(p>q)
   {
    err=addzone(q);
    if(err) break;
    cprintf("zone %s",q);
    p++;
   }
   if(ch==0) break;
  }
 }


 remkeyevent(optionskey,optionshandle,0);
 remclickevent(optionsicon,optionshandle,0);
 remcloseevent(optionsclose,optionshandle,0);

 err=closedown(&optionshandle);


 return(err);

 USE(w);
}





os_error * openoptions(int parent)
{
 os_error * err;

 if(optionshandle) err=forward(optionshandle,0,NULL);
 else
 {
  err=createwindowparent(TOPTIONS,&optionshandle,parent);
  if(!err)
  {
   addkeyevent(optionskey,optionshandle,0);
   addclickevent(optionsicon,optionshandle,0);
   addcloseevent(optionsclose,optionshandle,0);
   cc_spinrange(optionshandle,IDC_SPIN2,0,0x7FFF);
   writeiconf(optionshandle,IDC_TRES,"%d",timeresolution);
   selectst(optionshandle,IDC_SCRAPAUTO,scrapauto);

   err=popup(optionshandle,0);
   if(!err)
   {
    setfocus(optionshandle);
   }
  }
 }

 return(err);
}



/*********************************************************************************/


static int loghandle;



static os_error * logclose(int w,int userhandle);



static os_error * pathsave(char * name,int type)
{
 writeicon(loghandle,IDC_LOGNAME,name);

 return(NULL);
 USE(type);
}



#define TEXTTYPE 0xFFF


static os_error * opensavepath(void)
{
 os_error * err;
 char       savepath[MAX_PATH];

 err=NULL;

 readicon(loghandle,IDC_LOGNAME,savepath,MAX_PATH);

 err=opensaveparent(savepath,NITEM(savepath),TEXTTYPE,pathsave,loghandle);

 return(err);
}


static os_error * logicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;


 err=NULL;

 switch(m->i)
 {

   case IDC_LOGAPPEND:
                      err=selectst(handle,IDC_LOGAPPEND,logappend^=1);
                      break;

         case IDC_LOG:
                      err=selectst(handle,IDC_LOG,log^=1);
                      break;

   case IDC_BROWSELOG:
                      err=opensavepath();
                      break;

     case IDC_VIEWLOG:
                      err=viewdir(IDC_LOGNAME,handle);
                      break;
                         
            case IDOK:
                      err=logclose(handle,1);
                      break;

        case IDCANCEL:
                      err=logclose(handle,0);
                      break;

 }

 return(err);

 USE(userhandle);
}




static os_error * logkey(int handle,int userhandle,int icon,int * key)
{
 os_error    * err;
 int           ch;
 wimp_mousestr m;

 err=NULL;

 ch=*key;

 return(err);

 USE(icon);
}






static os_error * logclose(int w,int ok)
{
 os_error * err;

 if(ok)
 {
  readicon(loghandle,IDC_LOGNAME,logfile,sizeof(logfile));


 }


 remkeyevent(logkey,loghandle,0);
 remclickevent(logicon,loghandle,0);
 remcloseevent(logclose,loghandle,0);

 err=closedown(&loghandle);


 return(err);

 USE(w);
}





os_error * openlog(int parent)
{
 os_error * err;

 if(loghandle) err=forward(loghandle,0,NULL);
 else
 {
  err=createwindowparent(TLOGGING,&loghandle,parent);
  if(!err)
  {
   addkeyevent(logkey,loghandle,0);
   addclickevent(logicon,loghandle,0);
   addcloseevent(logclose,loghandle,0);
   selectst(loghandle,IDC_LOG,log);
   selectst(loghandle,IDC_LOGAPPEND,logappend);

   writeicon(loghandle,IDC_LOGNAME,logfile);

   err=popup(loghandle,0);
   if(!err)
   {
    setfocus(loghandle);
   }
  }
 }

 return(err);
}



/*********************************************************************************/


static int newhandle;



static os_error * newclose(int w,int userhandle);



static os_error * newicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;


 err=NULL;

 switch(m->i)
 {

                         
               case IDOK:
                         err=newclose(handle,1);
                         break;

           case IDCANCEL:
                         err=newclose(handle,0);
                         break;

 }

 return(err);

 USE(userhandle);
}




static os_error * newkey(int handle,int userhandle,int icon,int * key)
{
 os_error    * err;
 int           ch;
 wimp_mousestr m;

 err=NULL;

 ch=*key;

 return(err);

 USE(icon);
}






static os_error * newclose(int w,int ok)
{
 os_error * err;

 if(ok)
 {
//  readicon(loghandle,IDC_LOGNAME,logfile,sizeof(logfile));


 }


 remkeyevent(newkey,newhandle,0);
 remclickevent(newicon,newhandle,0);
 remcloseevent(newclose,newhandle,0);

 err=closedown(&newhandle);


 return(err);

 USE(w);
}





os_error * opennew(int parent)
{
 os_error * err;

 if(newhandle) err=forward(newhandle,0,NULL);
 else
 {
  err=createwindowparent(TNEWWORK,&newhandle,parent);
  if(!err)
  {
   addkeyevent(newkey,newhandle,0);
   addclickevent(newicon,newhandle,0);
   addcloseevent(newclose,newhandle,0);

   err=popup(newhandle,0);
   if(!err)
   {
    setfocus(newhandle);
   }
  }
 }

 return(err);
}


