/*->c.opendir */

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>




#include "os.h"
#include "flex.h"

#include "fsx.h"
#include "etc.h"
#include "bits.h"
#include "deb.h"


#include "zstring.h"

#include "arcs.h"


#include "opendir.h"


static int acmpfn(const void * p1,const void * p2)
{

 return(cstrcmp(zstringptr(((heads*)p1)->name),zstringptr(((heads*)p2)->name)));

}


static os_error * alphasortdir(heads * base,int start,int limit)
{

 qsort(base+start,limit-start,sizeof(heads),acmpfn);
 return(NULL);
}




typedef os_error * (*insertfn)(int acn,int ind,int fn,heads ** base);




static os_error * opendirsub(int acn,int ind,int * fnp,
                                                heads ** base,insertfn insfn)
{
 os_error * err;
 int        fn;
 char     * p;
 fxstat     f;
 int        eof;
 int        object;
 int        s;
 char       arcpath[NAMELEN];


 err=filepath(arcpath,acn,ind);
 if(!err) err=fs_exists(arcpath,&object);
 if(!err)
 {
  p=arcpath+strlen(arcpath);
  fn=*fnp;
  fs_startscan();

  if(!err)
  {
   while(1)
   {
    err=fs_nextitem(arcpath,&f,"*.*",&eof);
    if(err || eof) break;

    if(f.f.object)
    {
     err=insfn(acn,ind,fn,base);
     if(err) break;

     if(!cstrcmp(f.name,"thumbs.db")) cprintf("open dir %s %d",f.name,f.f.length);

     err=zcreatestring(f.name,&s);
     if(err) break;

     (*base)[fn].name=s;

     (*base)[fn].dirn=(f.f.object==2)?DFLAT:DNFILE;
     (*base)[fn].load=f.f.load;
     (*base)[fn].exec=f.f.exec;
     (*base)[fn].acc =f.f.acc;
     (*base)[fn].length=f.f.length;

     fn++;
    }
    if(err) break;
   }

   if(!err) alphasortdir(*base,*fnp,fn);

   *fnp=fn;
  }

  fs_endscan();
 }

 return(err);
}





#define HCHUNK (16*sizeof(heads))



/*
 * get the contents of directory specified by ind and fill into a temp
 * buffer.
 */

static os_error * getdirfn(int acn,int ind,int fn,heads ** base)
{
 os_error * err;

 if(!*base) err=flex_alloc((flex_ptr)base,HCHUNK);
 else       err=flex_chunk((flex_ptr)base,sizeof(heads)*(fn+1),HCHUNK);
 if(!err)   memset((*base)+fn,0,sizeof(heads));

 return(err);
 USE(acn);
 USE(ind);
}




os_error * opengetdir(int acn,int ind,heads ** hdr,int * size)
{
 *hdr=NULL;
 *size=0;
 return(opendirsub(acn,ind,size,hdr,getdirfn));
}




/*
 * get the contents of directory specified by ind and insert entries into
 * the main file header structure.
 */


static os_error * opendirfn(int acn,int ind,int fn,heads ** base)
{
 return(insentry(acn,fn,ind,1));
 USE(base);
}


os_error * opendir(int acn,int ind)
{
 os_error * err;
 int        fn;

 if(ind>=0)
 {
  arc[acn].hdr[ind].dirn=0;
 }
 fn=ind+1;                    /* nb is OK for fmain == -1 */
 err=opendirsub(acn,ind,&fn,&arc[acn].hdr,opendirfn);

 if(ind>=0 && err)
    arc[acn].hdr[ind].dirn=DFLAT;

// cprintf("acnxxx %d %x",acn,arc[acn].hdr);

 return(err);
}





os_error * loaddir(char * path,int * acnp)
{
 os_error * err;
 int        arcn;

 err=getarchandle(&arcn);
 if(!err)
 {
  *acnp=arcn;

  arc[arcn].path=path;

  err=opendir(arcn,-1);
 }

 return(err);
}


