/*->c.zone */

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>



#include "os.h"
#include "flex.h"


#include "deb.h"

#include "bits.h"

#include "fsx.h"
#include "bf.h"


#include "zone.h"



static char * zone;
static int    zonelen;



static os_error * addzones(char * path,int all)
{
 os_error * err;
 int        len;
 char     * p;

 err=NULL;


	cprintf("add zone %s",path);

 p=zone;
 while((p-zone)<zonelen)
 {
  len=strlen(p)+2;
  if(!cstrcmp(p,path))
  {
   *(p+len-1)=(char)all;
   break;
  }
  p+=len;
 }


 if((p-zone)>=zonelen)
 {
  len=strlen(path)+2;

  err=flex_extend((flex_ptr)&zone,zonelen+len);
  if(!err)
  {
   strcpy(zone+zonelen,path);
   zonelen+=len;
   zone[zonelen-1]=(char)all;
  }
 }


 return(err);
}



os_error * addzone(char * arg)
{
 int code;

 code=0;

 return(addzones(arg,code));
}






// return 1 to ignore this path

int inzone(char * path,int * all)
{
 char * p;
 int    len;
 char * q1;
 char * q10;
 char * q2;
 char * q20;
 int    c1;
 int    c2;


 p=zone;
 while(p<(zone+zonelen))
 {
  len=strlen(p)+2;

  /* is p the lhs of path? */

  if(strncmp(p,"...",3)==0)
  {
   q10=path;
   q20=p+3;
   while(*q20=='*') q20++;  // no ... *  sequence
   q1=q10+strlen(q10);
   q2=q20+strlen(q20);

   while(1)
   {
    c1=toupper(*q1--);
    c2=toupper(*q2--);

    if(c2=='?')
    {
     // matches anything    
    }
    else
    if(c2=='*')
    {
     c2=toupper(*q2);
     if(c2!='*')
     {
      if(c1!=c2) q2++;
      else       q2--;
     }
    }
    else
    { 
     if(c1!=c2) break;
    }

    if(q2<q20)
    {
     if(all) *all=*(p+len-1);
     return(1);
    }

    if(q1<q10) break;
   }
  }
  else
  {
   q1=path;
   q2=p;            // pattern

   while(1)
   {
    c2=toupper(*q2++);
    if(!c2) 
    {
     if(all) *all=*(p+len-1);
     return(1);
    }

    c1=toupper(*q1++);

    if(c2=='?')
    {
     // matches anything
    }
    else
    if(c2=='*')
    {
     c2=toupper(*q2);
     if(c2!='*')
     {
      if(c1!=c2) q2--;
      else
      if(c2) q2++;
     }
    }
    else
    {
     if(c1!=c2) break;
    }
   }
  }

  p+=len;
 }

 return(0);
}








os_error * zoneinit(void)
{
 os_error * err;
 
 err=flex_alloc((flex_ptr)&zone,0);
 zonelen=0;

/*
 addzone("....obj");
 addzone("....pch");
 addzone("....sbr");
 addzone("....idb");
 addzone("....bsc");
 addzone("....res");
 addzone("....lib");
*/


 return(err);
}



os_error * zoneclear(void)
{
 zonelen=0;
 return(NULL);
}

